	INCLUDE equates.h
	INCLUDE memory.h
	INCLUDE z80mac.h
	INCLUDE z80.h
	INCLUDE io.h
	INCLUDE gfx.h
	INCLUDE sn76496.h

	IMPORT findrom			;from main.c
	IMPORT pogoshell		;from main.c
	IMPORT pogosize			;from main.c

	EXPORT FillROMBANKMAP
	EXPORT WRAMEnable
	EXPORT loadcart
	EXPORT savestate
	EXPORT loadstate
	EXPORT g_emuflags
	EXPORT romstart			;used in sram.c
	EXPORT romnum
	EXPORT g_BIOSBASE_SMS
	EXPORT g_BIOSBASE_GG
	EXPORT g_scaling
	EXPORT g_scaling_set
	EXPORT g_cartflags
	EXPORT g_machine_set
	EXPORT g_config_set
	EXPORT g_region
;-------------------------------------------------------------------------------
 AREA rom_code, CODE, READONLY
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
loadcart ;called from C:  r0=rom number, r1=emuflags
;-------------------------------------------------------------------------------
	mov r2,#0
;-------------------------------------------------------------------------------
loadcartnew ;called from C:  r0=rom number, r1=emuflags, r2=clearmem?
;-------------------------------------------------------------------------------
	stmfd sp!,{r0-r2,r4-r11,lr}

	ldr r1,=findrom
	bl thumbcall_r1
	add r3,r0,#64				;r0 now points to rom image (including header)

	ldr globalptr,=|wram_globals1$$Base|	;need ptr regs init'd

	ldmfd sp!,{r0-r1}
	str r0,romnumber
	ldrb r0,scalemode
	orr r1,r1,r0,lsl#8
	str r1,emuflags
	ldrb r0,machine_set
	strb r0,machine
	ldrb r0,config_set
	strb r0,config

	ldr r1,=pogoshell
	ldrb r1,[r1]
	cmp r1,#0
								;r3=rombase til end of loadcart so DON'T FUCK IT UP
	ldrne r1,=pogosize
	ldrne r1,[r1]				;Size from Pogoshell
	ldreq r1,[r3,#-60]			;size of rom in bytes (from rombuilder).
	str r3,cartbase				;set cart base
	str r3,rombase				;set rom base

	cmp r1,#0x006000			;Mahjong, SG-1000 fix
	moveq r1,#0x008000			;-||-
	cmp r1,#0x00A000			;Monaco GP, SG-1000 fix
	moveq r1,#0x010000			;-||-
	cmp r1,#0x00C000			;Home Mahjong, SG-1000 fix
	moveq r1,#0x010000			;-||-
	cmp r1,#0x06C000			;Dodgeball fix
	moveq r1,#0x080000			;-||-
	cmp r1,#0x090000			;SF2 fix
	movhi r1,#0x100000			;-||-
	movs r2,r1,lsr#13			;Rom size in 8k banks
	subne r2,r2,#1
	str r2,rommask				;rommask=romsize-1
	str r2,rommask_backup		;rommask=romsize-1

	mov r0,r3
	bl MapperDetect
	mov r5,r0

	ldr r1,=0x02010000
	str r1,BankMap_Bios

	cmp r2,#0x4					;32kB
	ldrmi r1,=0x02010008		;RAM for SG1000 games
	cmp r0,#1
	ldreq r1,=0x00010000		;Codemaster...
	str r1,BankMap_Cart
	str r1,BankMap0

	ldr r4,=MEMMAPTBL_
	ldr r6,=WRMEMTBL_
	ldrmi r8,=rom_W
	ldreq r8,=Codemaster_W
	ldrhi r8,=Korean_W
	cmp r0,#3
	ldreq r8,=Korean_MSX_W
	mov r0,#0
tbloop1
	and r1,r0,r2
	add r1,r3,r1,lsl#14
	str r1,[r4,r0,lsl#2]
	str r8,[r6,r0,lsl#2]
	add r0,r0,#1
	cmp r0,#3
	bne tbloop1

	bl FillROMBANKMAP
	bl CheckMachine				;returns HW_Machine in r0.
	mov r9,r0

	ldrb r2,config
	mov r1,#0
	cmp r9,#HW_SMS1
	cmpne r9,#HW_SMS2
	ldreq r1,biosbase_sms		;SMS
	cmp r9,#HW_MD
	biceq r2,r2,#0x20			;Reset unavailable on HW_MD
	cmp r9,#HW_GG
	biceq r2,r2,#0x20			;Reset unavailable on HW_GG
	bicne r2,r2,#0x40			;R as Start only on HW_GG
	ldreq r1,biosbase_gg		;GG
	ldr r0,emuflags
	bicne r0,r0,#GG_MODE
	tst r0,#GG_MODE
	bicne r0,r0,#0x300			;Unscaled mode in GG_MODE
	str r0,emuflags
	strb r2,config
	cmp r1,#0
	moveq r1,r3
	str r1,biosbase
	mov r0,#7					;7 BIOS
	str r1,[r4,r0,lsl#2]		;MemMap
	str r8,[r6,r0,lsl#2]		;WrMem

	cmp r9,#HW_SG1000
	ldrne r8,=ram0_W
	ldreq r8,=ram2_W			;2k RAM mirrored
	ldr r1,=EMU_RAM
	mov r0,#3					;3 RAM
	str r1,[r4,r0,lsl#2]		;MemMap
	str r8,[r6,r0,lsl#2]		;WrMem

	beq is_sg_ram
	ldr r8,=ram1_W				;RAM without bankswitch
	cmp r5,#0
	bne is_sg_ram
	ldr r0,rommask
	cmp r0,#4
	ldrpl r8,=ram1S_W			;RAM with bank switch
is_sg_ram
	mov r0,#4					;4 RAM mirror
	str r1,[r4,r0,lsl#2]		;MemMap
	str r8,[r6,r0,lsl#2]		;WrMem

	ldr r1,=EMU_SRAM-0x8000
	ldr r8,=sram0_W				;5 SRAM
	mov r0,#5					;5 SRAM page 0
	str r1,[r4,r0,lsl#2]		;MemMap
	str r8,[r6,r0,lsl#2]		;WrMem

	ldr r1,=EMU_SRAM-0x4000
	ldr r8,=sram1_W				;6 SRAM
	mov r0,#6					;6 SRAM page 1
	str r1,[r4,r0,lsl#2]		;MemMap
	str r8,[r6,r0,lsl#2]		;WrMem


	ldr r0,=default_scanlinehook
	str r0,scanlinehook

	mov z80pc,#0				;(eliminates any encodePC errors during mapper*init)
	str z80pc,lastbank

	bl CopyCartToVRAM
	bl ShouldWeUseBIOS			;Check header and more...
	cmp r0,#0
	moveq r0,#0x80
	movne r0,#0x00
	ldrb r1,config
	ands r1,r1,r0				;BIOS on/off
	moveq r4,#0xAB				;Map in cartridge
	movne r4,#0xE3				;Map in BIOS

	strb r4,BankMap4			;address bus chipselects.
	bl InitMapper_
	bl reBankSwitch0_W
	bl reBankSwitch1_W
	bl reBankSwitch2_W
	bl reBankSwitchB_W

	ldmfd sp!,{r0}
	cmp r0,#0
	bne NoMemClear
	bl Mem_reset
	ldr r0,=EMU_RAM
	strb r4,[r0]				;simulate BIOS tag.
	mov r0,#0
NoMemClear
	bl GFX_reset				;now need r0 specified for palette clearing.
	bl IO_reset
	bl SOUND_reset
	bl CPU_reset
	ldmfd sp!,{r4-r11,lr}
	bx lr

;----------------------------------------------------------------------------
Mem_reset
;----------------------------------------------------------------------------
	stmfd sp!,{r4-r9,r11,lr}

	ldr r0,=DISABLEDMEM			;reset disabled memory
	mov r1,#-1		
	mov r2,#0x400/4
	bl memset_

	ldr r0,=EMU_SRAM			;clear RAM
	mov r1,#0		
	mov r2,#0x8000/4
	bl memset_

	ldrb r11,machine_set
	cmp r11,#HW_AUTO
	moveq r6,#0
	movne r6,#-1
	mov r2,r6,lsl#16
	mov r3,r6,lsr#16
	ldr r0,=VDP_RAM				;clear SMS VRAM.
	mov r1,#0x4000/8
vramLoop
	subs r1,r1,#1
	stmplia r0!,{r2,r3}
	bhi vramLoop

	mov r2,#0
	mov r3,r2
	mov r7,r6
	stmfd sp!,{r2,r3,r6,r7}
	ldmfd sp!,{r4,r5,r8,r9}
	ldr r0,=EMU_RAM				;clear SMS RAM.
	mov r1,#0x2000/64
wramLoop
	subs r1,r1,#1
	stmplia r0!,{r2-r5}
	stmplia r0!,{r2-r5}
	stmplia r0!,{r6-r9}
	stmplia r0!,{r6-r9}
	bhi wramLoop

	ldmfd sp!,{r4-r9,r11,lr}
	bx lr

;----------------------------------------------------------------------------
SOUND_reset
;----------------------------------------------------------------------------
	ldrb r0,machine
	cmp r0,#HW_SG1000
	mov r0,#0
	moveq r0,#1
	b SN76496_reset		;sound
;----------------------------------------------------------------------------
CheckMachine					;returns machine in r0.
;----------------------------------------------------------------------------
	ldr r0,rombase
	add r0,r0,#0x8000
	ldrb r2,[r0,#-1]
	and r2,r2,#0xF0
	ldrb r0,machine
	cmp r0,#HW_AUTO
	bne CM_NoCheck
	ldrb r1,emuflags
	and r1,r1,#GG_MODE
	cmp r1,#GG_MODE
	beq CM_NoGGCheck
	stmfd sp!,{r2,lr}
	bl CheckForHeader
	ldmfd sp!,{r2,lr}
	cmp r0,#0
	movne r2,#0
	cmp r2,#0x50				;GG Japan
	cmpne r2,#0x60				;GG Export
	cmpne r2,#0x70				;GG International
CM_NoGGCheck
	moveq r0,#HW_GG
	beq CM_IsGG
	cmp r2,#0x40				;SMS Export
	moveq r0,#HW_SMS2
	movne r0,#HW_SMS1
CM_IsGG
	strb r0,machine
CM_NoCheck
	ldrb r1,region
	cmp r1,#REGION_AUTO
	beq CM_CheckRegion
	ldrb r2,emuflags
	sub r1,r1,#1
	bic r2,r2,#3
	orr r2,r2,r1
	strb r2,emuflags
	bx lr
CM_CheckRegion
	ldrb r1,emuflags
	cmp r2,#0x50				;GG Japan
	cmpne r2,#0x30				;SMS Japan
	biceq r1,r1,#1				;clear PAL bit
	orreq r1,r1,#2				;set JP bit
	strb r1,emuflags

	bx lr

;----------------------------------------------------------------------------
ShouldWeUseBIOS				;returns r0!=0 if no header found or region Japan.
;----------------------------------------------------------------------------
	ldrb r0,machine_set
	cmp r0,#HW_AUTO
	mov r0,#0
	bxne lr						;Only check for header when HW=Auto
	stmfd sp!,{lr}
	bl CheckForHeader
	ldmfd sp!,{lr}
	cmp r0,#0
	bxne lr
	ldrb r0,[r1,#-0x01]
	and r0,r0,#0xF0
	cmp r0,#0x30				;SMS Japan
	moveq r0,#-1
	movne r0,#0
	bx lr
;----------------------------------------------------------------------------
CheckForHeader				;returns r0=0 if header found.
;----------------------------------------------------------------------------
	ldr r1,rombase
	add r1,r1,#0x8000
	ldr r0,[r1,#-0x10]
	ldr r2,=0x20524D54			;"TMR "
	subs r0,r0,r2
	ldreq r0,[r1,#-0x0C]
	ldreq r2,=0x41474553		;"SEGA"
	subeqs r0,r0,r2
	bx lr
;----------------------------------------------------------------------------
CopyCartToVRAM
;----------------------------------------------------------------------------
	stmfd sp!,{lr}

	ldr r0,=ROMCOPY				;destination
	ldr r1,cartbase				;source
	mov r2,#0x8000/32			;size
	bl memcpy_32

	ldr r0,=ROMCOPY+0x8000		;destination
	ldr r1,=0xFDFDFDFD			;value
	mov r2,#0x800/4				;size
	bl memset_

	ldmfd sp!,{lr}
	bx lr
;----------------------------------------------------------------------------
FillROMBANKMAP
;----------------------------------------------------------------------------
	stmfd sp!,{r2-r4,lr}

	ldr r3,rombase				;Get rom base
	ldr r2,rommask				;rommask=romsize-1

	ldr r4,=ROMBANKMAP
	mov r0,#0xFF
tbloop0
	and r1,r0,r2
	add r1,r3,r1,lsl#13			;8k banks
	str r1,[r4,r0,lsl#2]
	subs r0,r0,#1
	bpl tbloop0

	ldr r1,biosbase
	cmp r3,r1
	beq tb0end
	ldr r1,=ROMCOPY
	mov r0,#0x3
tbloop2
	str r1,[r4],#4
	add r1,r1,#0x2000
	subs r0,r0,#1
	bpl tbloop2
tb0end
	ldmfd sp!,{r2-r4,lr}
	bx lr

;----------------------------------------------------------------------------
InitMapper_	;rom paging..
;----------------------------------------------------------------------------
	ldr r2,=WRMEMTBL_
	adr r1,writemem_tbl

	ldr r0,[r2]
	str r0,[r1],#4				;writemem_tbl, WRITE_ROM
	str r0,[r1],#4				;writemem_tbl
	str r0,[r1],#4				;writemem_tbl
	str r0,[r1],#4				;writemem_tbl
	str r0,[r1],#4				;writemem_tbl
	str r0,[r1],#4				;writemem_tbl
	bx lr
;----------------------------------------------------------------------------
WRAMEnable	;Internal RAM enable/disable.
;----------------------------------------------------------------------------
	ldr r2,=WRMEMTBL_
	adr r1,writemem_tbl

	ldrb r0,BankMap4
	tst r0,#0x10
	ldrne r0,[r2]
	ldreq r0,[r2,#3*4]
	str r0,[r1,#6*4]			;writemem_tbl, WRITE_RAM
	ldreq r0,[r2,#4*4]
	str r0,[r1,#7*4]			;writemem_tbl, WRITE_RAM mirror
	adr r1,memmap_tbl+15*4
	bne RAMDisabled

	ldrb r0,machine
	cmp r0,#HW_SG1000

	ldr r0,[r2,#32+3*4]			;MEMMAPTBL_
	sub r0,r0,#0xC000
	beq InitRamMap_SG1000
	mov r2,#2
initm0loop
	str r0,[r1],#-4				;memmap_tbl
	str r0,[r1],#-4				;memmap_tbl
	str r0,[r1],#-4				;memmap_tbl
	str r0,[r1],#-4				;memmap_tbl
	str r0,[r1],#-4				;memmap_tbl
	str r0,[r1],#-4				;memmap_tbl
	str r0,[r1],#-4				;memmap_tbl
	str r0,[r1],#-4				;memmap_tbl
	sub r0,r0,#0x2000
	subs r2,r2,#1
	bne initm0loop
	bx lr

InitRamMap_SG1000
	mov r2,#8
initm1loop
	str r0,[r1],#-4				;memmap_tbl
	str r0,[r1],#-4				;memmap_tbl
	sub r0,r0,#0x800
	subs r2,r2,#1
	bne initm1loop
	bx lr

RAMDisabled
	ldr r0,=DISABLEDMEM-0xC000
	mov r2,#16
initm2loop
	str r0,[r1],#-4				;memmap_tbl
	sub r0,r0,#0x400
	subs r2,r2,#1
	bne initm2loop
	bx lr

;-------------------------------------------------------------------------------
MapperDetect		;In r0=rombase, r1=size.
					;Out r0=mapper, 0=Sega, 1=Codemaster, 2=Korean, 3=Korean MSX.
					;Adapted from Meka.
;-------------------------------------------------------------------------------
	cmp r1,#0x8000
	movle r0,#0
	bxle lr

	stmfd sp!,{r2-r8}
	mov r3,#0					;0x8000
	mov r4,#0					;0xA000
	mov r5,#0					;0xFFFF
	mov r6,#0					;0x0002
	mov r7,#0x8000				;compare size
	mov r8,#-1
MDloop
	ldrb r1,[r0],#1
	cmp r1,#0x32				;Z80 opcode for: LD (xxxx), A
	beq MDe
MDe2
	subs r7,r7,#1
	bne MDloop
	mov r0,#0

	add r1,r5,#1				;2?
	cmp r3,r1
	movhi r0,#1
	movhi r3,r1
	cmp r4,r1
	movhi r0,#2
	movhi r4,r1
	cmp r6,r1
	movhi r0,#3

	ldmfd sp!,{r2-r8}
	bx lr

MDe
	ldrb r1,[r0]
	ldrb r2,[r0,#1]
	orr r1,r1,r2,lsl#8
	cmp r1,#0x8000				;Codemaster mapper
	cmpne r1,#0x4000			;For Ernie Els Golf. Hopefully doesn't break anything.
	addeq r3,r3,#1
	addeq r0,r0,#2
	cmp r1,#0xA000				;Korean mapper
	addeq r4,r4,#1
	addeq r0,r0,#2
	cmp r1,r8,lsr#16			;SEGA mapper
	addeq r5,r5,#1
	addeq r0,r0,#2
	cmp r1,#0x0002				;Korean MSX mapper
	cmpne r1,#0x0003
	cmpne r1,#0x0001
	addeq r6,r6,#1
	addeq r0,r0,#2
	b MDe2
;-------------------------------------------------------------------------------
savestate	;called from ui.c.
;int savestate(void): return size.
;-------------------------------------------------------------------------------
	stmfd sp!,{r4-r9,globalptr,lr}
	ldr globalptr,=|wram_globals1$$Base|

	bl fixCpuPC_save			;adjust cpu pc (so savestates are valid after moving roms around)

	ldr r6,=STATEPTR			;r6=where state is at
	mov r0,#0					;r0 holds total size (return value)

	adr r4,savelst				;r4=list of stuff to copy
	mov r3,#(lstend-savelst)/8	;r3=items in list
ss1	ldmia r4!,{r1,r2}			;r1=what to copy, r2=how much to copy
	add r0,r0,r2
ss0	ldr r5,[r1],#4
	str r5,[r6],#4
	subs r2,r2,#4
	bne ss0
	subs r3,r3,#1
	bne ss1

	mov r4,r0					;save r0.
	bl fixCpuPC_load
	ldr r1,=0xE080				;Size of all RAM including PaletteRAM.
	add r0,r1,r4

	ldmfd sp!,{r4-r9,globalptr,lr}
	bx lr

;savelst	DCD rominfo,8,EMU_SRAM,0xE000,cpustate,104,gfxstate-16,72,SoundVariables,56,BankState,24,SMSPALBUFF,544
;savelst	DCD rominfo,8,cpustate,104,gfxstate-16,72,SoundVariables,56,BankState,24,PALETTE_RAM,0xE040
savelst	DCD rominfo,8,cpustate,104,gfxstate-16,80,SoundVariables,56,BankState,24
lstend

fixCpuPC_save
	ldr r2,lastbank
	ldr r3,cpuregs+6*4			;Z80 PC
	sub r3,r3,r2
	str r3,cpuregs+6*4

	bx lr

fixCpuPC_load
	ldr z80pc,cpuregs+6*4		;Z80 PC
	encodePC
	str z80pc,cpuregs+6*4

	bx lr
;-------------------------------------------------------------------------------
loadstate	;called from ui.c
;void loadstate(int rom#)	 (stateptr must be word aligned)
;-------------------------------------------------------------------------------
	stmfd sp!,{r4-r9,globalptr,lr}
	ldr globalptr,=|wram_globals1$$Base|

	ldr r6,=STATEPTR			;r6=where state is at
	ldrb r4,scalemode			;preserve scalmode config

	ldr r1,[r6]					;emuflags
	ldrb r2,[r6,#1]				;emuflags
	strb r2,scalemode			;change scalemode before loadcart

	mov r2,#1
	bl loadcartnew				;cart init, without memclear.
	strb r4,scalemode			;restore scalemode config

	mov r0,#(lstend-savelst)/8	;read entire state
	adr r4,savelst
ls1	ldmia r4!,{r1,r2}
ls0	ldr r5,[r6],#4
	str r5,[r1],#4
	subs r2,r2,#4
	bne ls0
	subs r0,r0,#1
	bne ls1

	ldrb r0,BankMap4
	ldr r1,biosbase
	tst r0,#0x40				;ROM?
	ldreq r1,cartbase
	tst r0,#0x08				;BIOS?
	ldrne r1,cartbase

	str r1,rombase

	bl FillROMBANKMAP
	bl reBankSwitch0_W
	bl reBankSwitch1_W
	bl reBankSwitch2_W

	bl fixCpuPC_load

	ldrb r0,vdpctrl
	ldr r1,=VDPMemDest
	ldr r0,[r1,r0,lsl#2]
	ldr r1,=VDPdata_W_ptr
	str r0,[r1]
	mov r0,#0xff
	strb r0,vdprmode

	bl cleardirtytiles
	bl PaletteTxAll

	ldmfd sp!,{r4-r9,globalptr,lr}
	bx lr


;-------------------------------------------------------------------------------
 AREA wram_globals3, CODE, READWRITE

	DCD 0 ;biosbase
romstart
	DCD 0 ;cartbase
	DCD 0 ;rombase
romnum
	DCD 0 ;romnumber
rominfo                 ;keep emuflags/BGmirror together for savestate/loadstate
g_emuflags	DCB 0 ;emuflags        (label this so UI.C can take a peek) see equates.h for bitfields
g_scaling	DCB SCALED_SPRITES ;(display type)
	% 2   ;(sprite follow val)

	DCD 0 ;rommask
	DCD 0 ;rommask_backup
	DCD 0 ;BGoffset1
	DCD 0 ;BGoffset2
	DCD 0 ;BGoffset3
g_BIOSBASE_SMS
	DCD 0 ;biosbase_sms, SMS
g_BIOSBASE_GG
	DCD 0 ;biosbase_gg, GG
g_scaling_set
	DCB 0 ;scalemode(saved display type)
g_cartflags
	DCB 0 ;cartflags
g_machine
	DCB 0 ;machine
g_machine_set
	DCB 0 ;machine_set
g_config
	DCB 0		;config, bit 7=BIOS on/off, bit 6=R as Start,
g_config_set
	DCB 0
g_region
	DCB 0		;0=Auto, 1=USA, 2=Euro, 3=Japan.
	DCB 0		;align
BankState
	DCD 0		;BankMap_Exp
	DCD 0		;BankMap_Card
	DCD 0		;BankMap_Cart
	DCD 0		;BankMap_Bios
	DCB 0,0,0,0	;BankMap0,1,2,3
	DCB 0,0,0,0	;BankMap4, IO control (BIOS select), + alignment.
;----------------------------------------------------------------------------
	END

