		GBLL DEBUG
		GBLL SAFETY

DEBUG		SETL {FALSE}

;BUILD		SETS "DEBUG"/"GBA"	(defined at cmdline)
;----------------------------------------------------------------------------
	INCLUDE gba_hw.h

;YSCALE_EXTRA		EQU 0x03007B00
;YSCALE_LOOKUP		EQU YSCALE_EXTRA+0x50
;?					EQU YSCALE_LOOKUP+0x200		; was 0x100

VDP_RAM				EQU 0x02040000-0x4000
EMU_RAM 			EQU VDP_RAM-0x2000
EMU_SRAM			EQU EMU_RAM-0x8000
PALETTE_RAM			EQU EMU_SRAM-0x80
STATEPTR			EQU PALETTE_RAM-0x110
SMSPALBUFF			EQU STATEPTR-512*2			;GBA palette buffer, also in GBA.h
MAPPED_RGB			EQU SMSPALBUFF-4096*2			;Palette lookup
SMSOAMBUFF	 		EQU MAPPED_RGB-0x180
OAM_BUFFER2 		EQU SMSOAMBUFF-0x400
OAM_BUFFER1 		EQU OAM_BUFFER2-0x400
SCROLLBUFF1			EQU OAM_BUFFER1-240
SCROLLBUFF2			EQU SCROLLBUFF1-240
TMAPBUFF			EQU SCROLLBUFF2-240
DIRTYTILES_			EQU TMAPBUFF-512
ROMBANKMAP			EQU DIRTYTILES_-256*4
MEMMAPTBL_			EQU ROMBANKMAP-8*4
WRMEMTBL_			EQU MEMMAPTBL_-8*4
FREQTBL				EQU WRMEMTBL_-1024*2
YSCALE_LOOKUP		EQU FREQTBL-0x200
YSCALE_EXTRA		EQU YSCALE_LOOKUP-0x50
PCMWAVSIZE			EQU 528
PCMWAV				EQU YSCALE_EXTRA-PCMWAVSIZE*4
DISABLEDMEM			EQU PCMWAV-0x400
END_OF_EXRAM		EQU DISABLEDMEM-0x6000					; > 0x6000 room left for code.


CHR_DECODE			EQU 0x6004400						;0x400
;EmptyTile			EQU 0x6004000
DMA0BUFF			EQU 0x6001800						;~0x0C00
ROMCOPY				EQU 0x600B800						;0x8000

DEBUGSCREEN			EQU AGB_VRAM+0x3800


			;r0,r1,r2=temp regs
z80f		RN r3	;see z80mac.h
z80a		RN r4	;bits 0-15=0
z80bc		RN r5	;bits 0-15=0
z80de		RN r6	;bits 0-15=0
z80hl		RN r7	;bits 0-15=0
cycles		RN r8
z80pc		RN r9
globalptr	RN r10	;=wram_globals* ptr
z80optbl	RN r10
z80sp		RN r11	;bits 0-15=0
addy		RN r12	;keep this at r12 (scratch for APCS)
z80xy		RN lr	;pointer to IX or IY reg
			;r13=SP
			;r14=LR
			;r15=PC
;----------------------------------------------------------------------------

;everything in wram_globals* areas:

 MAP 0,globalptr	;z80.s
memmap_tbl_offset # -64*4
memmap_tbl # 64*4
opz # 256*4
pzst # 256
writemem_tbl # 8*4
cpuregs # 8*4
cpuregs2 # 8*4
z80_ix # 4
z80_iy # 4
lastbank # 4
z80_iff1 # 1
z80_iff2 # 1
z80_im # 1
z80_if_ # 1
z80_i # 1
z80_r # 1
z80_out0 # 1
z80_temp2 # 1
nexttimeout # 4
nexttimeout_ # 4
oldcycles # 4
scanlinehook # 4
			;gfx.s (wram_globals1)
fpsvalue # 4
AGBjoypad # 4
EMUjoypad # 4
adjustblend # 4
windowtop # 16
scanline # 4
frame # 4
lastscanline # 4
vramaddr # 4
lineirq # 4
endframeline # 4
vblline # 4
scanlinebp # 4
scrollmask # 4
sprstop # 4

vdpmode1 # 1
vdpmode2 # 1
nametable # 1
ctoffset # 1
pgoffset # 1
satoffset # 1
sproffset # 1
bdcolor # 1
vdpxscroll # 1
vdpyscroll # 1
vdpcounter # 1

vdpctrl # 1
vdpbuff # 1		;buff & toggle need to be together/aligned.
 # 1			;align
toggle # 1		; -- || --
 # 1			;align
vdpstat # 1
vdppending # 1
vdpcalcmode # 1
vdprmode # 1
vdpheightmode # 1
vdpmode2_bak1 # 1
vdpmode2_bak2 # 1
vdpyscroll1 # 1
vdpyscroll2 # 1
ntmask # 1
minpan # 1
maxpan # 1
scrstartline # 1
irqControl # 1
irqPending # 1
ystart # 1		;6 scaled SMS 224 screen starts on this line
sprBank # 1
scanlineminus # 1
vdpbuff_md # 1
hcountlatch # 1
hcountoffset # 1
 # 2	;align
lockpanel # 1
			;cart.s (wram_globals2)
biosbase # 4
cartbase # 4
rombase # 4
romnumber # 4
emuflags # 4

rommask # 4
rommask_backup # 4
BGoffset1 # 4
BGoffset2 # 4
BGoffset3 # 4
biosbase_sms # 4
biosbase_gg # 4
scalemode # 1	;this is saved to the config (GG/SMS mode shit)
cartflags # 1
machine # 1
machine_set # 1
config # 1
config_set # 1
region # 1
 # 1	;align
BankMap_Exp # 4
BankMap_Card # 4
BankMap_Cart # 4
BankMap_Bios # 4
BankMap0 # 1
BankMap1 # 1
BankMap2 # 1
BankMap3 # 1
BankMap4 # 1
 # 3 ;align for savestate

;-----------------------------------------------------------machine
HW_AUTO			EQU 0
HW_SG1000		EQU 1
HW_SMS1			EQU 2
HW_SMS2			EQU 3
HW_GG			EQU 4
HW_MD			EQU 5
;-----------------------------------------------------------vdp modes
VDPMODE_0		EQU 0x00
VDPMODE_1		EQU 0x01
VDPMODE_2		EQU 0x02
VDPMODE_3		EQU 0x03
VDPMODE_4		EQU 0x04
VDPMODE_4_224	EQU 0x14
VDPMODE_4_240	EQU 0x24
VDPMODE_5		EQU 0x05
VDPMODE_5_224	EQU 0x15
VDPMODE_5_240	EQU 0x25
VDPMODE_B		EQU 0xFF
;-----------------------------------------------------------region
REGION_AUTO		EQU 0
REGION_US		EQU 1
REGION_PAL		EQU 2
REGION_JAPAN	EQU 3
;-----------------------------------------------------------cartflags
SRAM			EQU 0x02 ;save SRAM
;-----------------------------------------------------------emuflags
PALTIMING		EQU 1	;0=NTSC 1=PAL timing
COUNTRY			EQU 2	;0=World 1=JAP
GG_MODE			EQU 4	;0=SMS mode, 1=GG mode
;?				EQU 16
FOLLOWMEM		EQU 32  ;0=follow sprite, 1=follow mem

				;bits 8-15=scale type

UNSCALED_NOAUTO	EQU 0	;display types
UNSCALED_AUTO	EQU 1
SCALED			EQU 2
SCALED_SPRITES	EQU 3

				;bits 16-31=sprite follow val

;----------------------------------------------------------------------------
CYC_SHIFT		EQU 8
CYCLE			EQU 1<<CYC_SHIFT ;one cycle (228*CYCLE cycles per scanline)

;cycle flags- (stored in cycles reg for speed)

CYC_C			EQU 0x01	;Carry bit
CYC_I			EQU 0x04	;IRQ mask
CYC_D			EQU 0x08	;Decimal bit
CYC_V			EQU 0x40	;Overflow bit
CYC_MASK		EQU CYCLE-1	;Mask
;----------------------------------------------------------------------------

		END

