#include <stdio.h>
#include <string.h>

#include "gba.h"
#define ARRSIZE(xxxx) (sizeof((xxxx))/sizeof((xxxx)[0]))
#define VERSION "V2.5"

//header files?  who needs 'em :P

extern u8 Image$$RO$$Limit;

extern void cls(int);					//from main.c
extern void initpalette(void);
extern void rommenu(void);
extern int getmenupos(int keyhit, int sel, int menuitems);
extern int getromsize(void);	//from main.c
extern u8 *findrom(int);		//from main.c

void drawtext(int,const char *,int);	//from main.c
void setdarknessgs(int dark);
void setbrightnessall(int light);
extern u8 *textstart;
void quicksave(void);			//sram.c
void quickload(void);			//sram.c
void savestatemenu(void);		//sram.c
void loadstatemenu(void);
int check_for_sms_sram(void);
void save_sms_sram(void);
//void load_sms_sram(void);
void writeconfig(void);			//sram.c
void managesram(void);			//sram.c


extern int SendMBImageToClient(void);	//mbclient.c
extern u32 max_multiboot_size;

//----asm calls------
void resetSIO(u32);			//io.s
void doReset(void);			//io.s
void suspend(void);			//io.s
void waitframe(void);		//io.s
int gettime(void);			//io.s
void spriteinit(char);		//io.s
void debug_(int val,int line);	//gfx.s
void paletteinit(void);		//gfx.s
void PaletteTxAll(void);	//gfx.s
void endframe(void);		//gfx.s
void makeborder(void);		//gfx.s
void scanlinebp_reset(void);//gfx.s
void VDPreg0_Update(void);	//gfx.s
void loadcart(int,int);		//cart.s
void savestate(void);		//cart.s
void loadstate(void);		//cart.s
void ntsc_pal_reset(void);	//z80.s
void frequency_reset(void);	//sn76496.s
//-------------------

extern u32 joycfg;			//from io.s
extern char g_emuflags;		//from cart.s
extern char g_scaling;		//from cart.s
extern char g_scaling_set;	//from cart.s
extern char g_machine_set;	//from cart.s
extern char g_config_set;	//from cart.s
extern char g_region;		//from cart.s
extern char *romstart;		//from cart.s
extern u8 *g_BIOSBASE_SMS;	//from cart.s
extern u8 *g_BIOSBASE_GG;	//from cart.s
extern char novblankwait;	//from z80.s
extern char sprcollision;	//from z80.s
extern u32 sleeptime;		//from z80.s
extern u32 FPSValue;		//from gfx.s
extern u32 oambufferready;	//from gfx.s
extern char fpsenabled;		//from gfx.s
extern char gammavalue;		//from gfx.s
extern char bcolor;			//from gfx.s border color
extern char twitch;			//from gfx.s
extern char g_flicker;		//from gfx.s
extern char toprows;		//from gfx.s
extern char SPRS;			//from gfx.s
extern char gfxlayermask;	//from gfx.s
extern char g_lockpanel;	//from gfx.s

extern char rtc;
extern char pogoshell;
extern char gameboyplayer;
extern char gbaversion;
extern int selectedrom;
extern int roms;

u8 autoA,autoB;				//0=off, 1=on, 2=R
u8 stime=0;
u8 ewram=0;
u8 autostate=0;

void autoAset(void);
void autoBset(void);
void swapAB(void);
void controller(void);
void vblset(void);
void restart(void);
void exit(void);
void multiboot(void);
void go_multiboot(void);
void scrolll(int offset, int f);
void scrollr(int offset);
void drawui1(void);
void drawui2(void);
void drawui3(void);
void drawui4(void);
void drawui5(void);
void drawui6(void);
void subui(int menunr);
void ui2(void);
void ui3(void);
void ui4(void);
void ui5(void);
void ui6(void);
void textui(void);
void drawclock(void);
void sleep(void);
void sleepset(void);
void fpsset(void);
void brightset(void);
void fadetowhite(void);
void ewramset(void);
void autostateset(void);
void display(void);
void flickset(void);
void toprowset(void);
void borderset(void);
void soundset(void);
void countryset(void);
void biosset(void);
void rstartset(void);
void selectset(void);
void machineset(void);
void spriteset(void);
void collisionset(void);
void bgrlayerset(void);
void sprlayerset(void);

//#define MENU2ITEMS 9			//othermenu items
//#define MENU3ITEMS 8			//displaymenu items
//#define MENU4ITEMS 6			//controllermenu items
//#define MENU5ITEMS 6			//savemanager items
//#define CARTMENUITEMS 10		//mainmenuitems when running from cart (not multiboot)
//#define MULTIBOOTMENUITEMS 7	//"" when running from multiboot
const fptr fnlist1[]={ui4,ui3,ui2,textui,multiboot,go_multiboot,ui5,sleep,restart,exit};
const fptr fnlist1mb[]={ui4,ui3,ui2,textui,multiboot,sleep,restart};		//MultiBoot menu
const fptr fnlist2[]={vblset,fpsset,sleepset,ewramset,autostateset,collisionset,countryset,biosset,machineset};
const fptr fnlist3[]={display,flickset,brightset,borderset,toprowset,spriteset,bgrlayerset,sprlayerset};
const fptr fnlist4[]={autoBset,autoAset,controller,swapAB,rstartset,selectset};
const fptr fnlist5[]={quicksave,quickload,savestatemenu,loadstatemenu,save_sms_sram,managesram};

const u8 menuXitems[]={ARRSIZE(fnlist1),ARRSIZE(fnlist1mb),ARRSIZE(fnlist2),ARRSIZE(fnlist3),ARRSIZE(fnlist4),ARRSIZE(fnlist5)};
const fptr *const fnlistX[]={fnlist1,fnlist1mb,fnlist2,fnlist3,fnlist4,fnlist5};
const fptr drawuiX[]={drawui1,drawui1,drawui2,drawui3,drawui4,drawui5};

int selected;//selected menuitem.  used by all menus.
int mainmenuitems;//? or CARTMENUITEMS, depending on whether saving is allowed
int tm0cnt;			//Used when doing restart

u32 oldkey;//init this before using getmenuinput
u32 getmenuinput(int menuitems) {
	u32 keyhit;
	u32 tmp;

	waitframe();		//(polling REG_P1 too fast seems to cause problems)
	tmp=~REG_P1;
	keyhit=(oldkey^tmp)&tmp;
	oldkey=tmp;
	selected = getmenupos(keyhit, selected, menuitems);
	if((oldkey&(L_BTN+R_BTN))!=L_BTN+R_BTN)
		keyhit&=~(L_BTN+R_BTN);
	return keyhit;
}

void ui() {
	int key,oldsel,i,is_mb;
	ewram=((REG_WRWAITCTL & 0x0F000000) == 0x0E000000)?1:0;
	g_lockpanel = 0;

	autoA=joycfg&A_BTN?0:1;
	autoA|=joycfg&(A_BTN<<16)?0:2;
	autoB=joycfg&B_BTN?0:1;
	autoB|=joycfg&(B_BTN<<16)?0:2;

	is_mb = (u32)textstart<0x8000000;
	mainmenuitems=menuXitems[is_mb];
	FPSValue=0;					//Stop FPS meter

	tm0cnt=REG_TM0CNT;
	REG_TM0CNT=0;				//stop sound (directsound)

	selected=0;
	waitframe();
	REG_BG3HOFS=0x100;
	initpalette();
	if(check_for_sms_sram() >= 0) {
		save_sms_sram();
	}
	drawui1();
	for(i=0;i<8;i++)
	{
		waitframe();
		setdarknessgs(i);		//Darken game screen
		REG_BG3HOFS=224-i*32;	//Move screen right
		REG_BG3VOFS=0;			//Clear V scroll
	}

	oldkey=~REG_P1;			//reset key input
	do {
		drawclock();
		key=getmenuinput(mainmenuitems);
		if(key&(A_BTN)) {
			oldsel=selected;
			fnlistX[is_mb][selected]();
			selected=oldsel;
		}
		if(key&(A_BTN+UP+DOWN+LEFT+RIGHT))
			drawui1();
	} while(!(key&(B_BTN+R_BTN+L_BTN)));
	writeconfig();			//save any changes
	for(i=1;i<9;i++)
	{
		waitframe();
		setdarknessgs(8-i);	//Lighten screen
		REG_BG3HOFS=i*32;	//Move screen left
	}
	cls(3);
//	PaletteTxAll();			//restore EMU palette
	VDPreg0_Update();
	oambufferready=1;
	while(key&(B_BTN)) {
		waitframe();		//(polling REG_P1 too fast seems to cause problems)
		key=~REG_P1;
	}
	REG_TM0CNT=tm0cnt;		//resume sound (directsound)
}

void textui(void) {
	int key;

	drawui6();
	scrolll(0,0);
	oldkey=~REG_P1;			//reset key input
	do {
		key=getmenuinput(1);
	} while(!(key&(B_BTN+R_BTN+L_BTN)));
	scrollr(0);
	while(key&(B_BTN)) {
		waitframe();		//(polling REG_P1 too fast seems to cause problems)
		key=~REG_P1;
	}
}

void subui(int menunr) {
	int key,oldsel;

	selected=0;
	drawuiX[menunr]();
	scrolll(0,0);
	oldkey=~REG_P1;			//reset key input
	do {
		key=getmenuinput(menuXitems[menunr]);
		if(key&(A_BTN)) {
			oldsel=selected;
			fnlistX[menunr][selected]();
			selected=oldsel;
		}
		if(key&(A_BTN+UP+DOWN+LEFT+RIGHT)) {
			drawuiX[menunr]();
		}
	} while(!(key&(B_BTN+R_BTN+L_BTN)));
	drawui1();
	scrollr(0);
	while(key&(B_BTN)) {
		waitframe();		//(polling REG_P1 too fast seems to cause problems)
		key=~REG_P1;
	}
}

void ui2() {
	subui(2);
}
void ui3() {
	subui(3);
}
void ui4() {
	subui(4);
}
void ui5() {
	subui(5);
}

void text(int row,const char *str) {
	drawtext(row+10-mainmenuitems/2,str,selected==row);
}
void text2(int row,const char *str) {
	drawtext(35+row+2,str,selected==row);
}


//trying to avoid using sprintf...  (takes up almost 3k!)
void strmerge(char *dst,const char *src1,const char *src2) {
	if(dst!=src1)
		strcpy(dst,src1);
	strcat(dst,src2);
}

char *const autotxt[]={"OFF","ON","with R"};
char *const vsynctxt[]={"ON","Force","OFF","SLOWMO"};
char *const sleeptxt[]={"5min","10min","30min","OFF"};
char *const brightxt[]={"I","II","III","IIII","IIIII"};
char *const memtxt[]={"Normal","Turbo"};
char *const hostname[]={"Crap","Prot","GBA","GBP","NDS"};
char *const ctrltxt[]={"1P","2P","Link"};
char *const bordtxt[]={"Black","Border Color","None"};
char *const disptxt[]={"UNSCALED","UNSCALED (Auto)","SCALED","SCALED (w/sprites)"};
char *const flicktxt[]={"No Flicker","Flicker"};
char *const cntrtxt[]={"Auto","US (NTSC)","Europe (PAL)","Japan (NTSC)"};
char *const machtxt[]={"Auto","SG-1000","Master System","Master System 2","Game Gear","Mega Drive"};
char *const checksize[]={"256","512","1024","0","0","0","0","0","0","0","8","16","32","48","64","128"};
char *const soundtxt[]={"OFF","ON","ON(Mixer)"};
char *const emuname[]={"      SMSAdvance ","  PogoSMSAdvance "};

void drawui1() {
	int i=0;
	char str[30];

	cls(1);
	drawtext(18,"     FluBBa Power 2008!",0);
	if(pogoshell) i=1;
	strmerge(str,emuname[i],VERSION " on ");
	strmerge(str,str,hostname[gbaversion]);
	drawtext(19,str,0);

	i = 0;
	text(i++,"Controller->");
	text(i++,"Display->");
	text(i++,"Other Settings->");
	text(i++,"Help->");
	text(i++,"Link Transfer");
	if(mainmenuitems!=menuXitems[1]){
		text(i++,"Go Multiboot");
		text(i++,"Save Manager->");
	}
	text(i++,"Sleep");
	text(i++,"Restart");
	if(mainmenuitems!=menuXitems[1]){
		text(i,"Exit");
	}
}

void drawui2() {
	char str[30];

	cls(2);
	drawtext(32,"       Other Settings",0);
	strmerge(str,"VSync: ",vsynctxt[novblankwait]);
	text2(0,str);
	strmerge(str,"FPS-Meter: ",autotxt[fpsenabled]);
	text2(1,str);
	strmerge(str,"Autosleep: ",sleeptxt[stime]);
	text2(2,str);
	strmerge(str,"EWRAM speed: ",memtxt[ewram]);
	text2(3,str);
	strmerge(str,"Autoload state: ",autotxt[autostate&1]);
	text2(4,str);
	strmerge(str,"Fake Spritecollision: ",autotxt[(sprcollision>>5)&1]);
	text2(5,str);
	strmerge(str,"Region: ",cntrtxt[g_region]);
	text2(6,str);
	strmerge(str,"Use BIOS: ",autotxt[(g_config_set>>7)&1]);
	text2(7,str);
	strmerge(str,"Machine: ",machtxt[g_machine_set]);
	text2(8,str);
}

void drawui3() {
	char str[30];

	cls(2);
	drawtext(32,"      Display Settings",0);
	strmerge(str,"Display: ",disptxt[g_scaling_set&3]);
	text2(0,str);
	strmerge(str,"Scaling: ",flicktxt[g_flicker]);
	text2(1,str);
	strmerge(str,"Gamma: ",brightxt[gammavalue]);
	text2(2,str);
	strmerge(str,"GG Border: ",bordtxt[bcolor]);
	text2(3,str);
	strmerge(str,"Lock Toprows: ",vsynctxt[toprows]);
	text2(4,str);
	strmerge(str,"Perfect Sprites: ",autotxt[SPRS]);
	text2(5,str);
	strmerge(str,"Disable Background: ",autotxt[gfxlayermask&1]);
	text2(6,str);
	strmerge(str,"Disable Sprites: ",autotxt[(gfxlayermask>>4)&1]);
	text2(7,str);
}

void drawui4() {
	char str[30];

	cls(2);
	drawtext(32,"    Controller Settings",0);
	strmerge(str,"B autofire: ",autotxt[autoB]);
	text2(0,str);
	strmerge(str,"A autofire: ",autotxt[autoA]);
	text2(1,str);
	strmerge(str,"Controller: ",ctrltxt[joycfg>>30]);
	text2(2,str);
	strmerge(str,"Swap A-B:   ",autotxt[(joycfg>>10)&1]);
	text2(3,str);
	strmerge(str,"Use R as Start: ",autotxt[(g_config_set>>6)&1]);
	text2(4,str);
	strmerge(str,"Use Select as Reset: ",autotxt[(g_config_set>>5)&1]);
	text2(5,str);
}

void drawui5() {
	cls(2);
	drawtext(32,"     Savememory Manager",0);

	text2(0,"Quick SaveState  (R+Select)");
	text2(1,"Quick LoadState  (R+Start)");
	text2(2,"SaveState->");
	text2(3,"LoadState->");
	text2(4,"Save SRAM");
	text2(5,"Manage Savememory->");
}

void drawui6() {
	int i;
	char str1[30];
	char str2[30];

	cls(2);
	drawtext(32,"     Help instructions",0);
	drawtext(34,"DPad:   Move character",0);
	drawtext(35,"B:      Button 1",0);
	drawtext(36,"A:      Button 2",0);
	drawtext(37,"Start:  Pause/Start",0);
	drawtext(38,"Select: Reset?",0);
	drawtext(39,"R:      Start?",0);
	drawtext(41,"    Header info:",0);
	i = (char)*(romstart+0x7FFF);

	strcpy(str1,"Machine: ");
	strcpy(str2,"Region:  ");
	switch(i&0xF0){
		case 0x30:
			strmerge(str1,str1,"Master System");
			strmerge(str2,str2,"JP");
			break;
		case 0x40:
			strmerge(str1,str1,"Master System");
			strmerge(str2,str2,"Export");
			break;
		case 0x50:
			strmerge(str1,str1,"GameGear");
			strmerge(str2,str2,"JP");
			break;
		case 0x60:
			strmerge(str1,str1,"GameGear");
			strmerge(str2,str2,"Export");
			break;
		case 0x70:
			strmerge(str1,str1,"GameGear");
			strmerge(str2,str2,"International");
			break;
	}
	drawtext(43,str1,0);
	drawtext(44,str2,0);

	strcpy(str1,"CheckSize: ");
	i &= 0x0F;
	strmerge(str1,str1,checksize[i]);
	strmerge(str1,str1,"kB");
	drawtext(47,str1,0);

	strcpy(str1,"Version:  ");
	i = (char)*(romstart+0x7FFE);
	str1[10] = (i & 0x0F) + 0x30;
	str1[11] = 0;
	drawtext(46,str1,0);

	strcpy(str1,"Product nr:  ");
	i = ((i & 0xF0)>>4) + 0x30;
	if( i == 0x30) i = 0x20;
	str1[12] = i;
	i = (char)*(romstart+0x7FFD);
	str1[13] = ((i & 0xF0)>>4) + 0x30;
	str1[14] = (i & 0x0F) + 0x30;
	i = (char)*(romstart+0x7FFC);
	str1[15] = ((i & 0xF0)>>4) + 0x30;
	str1[16] = (i & 0x0F) + 0x30;
	str1[17] = 0;
	drawtext(45,str1,0);
	
	
	drawtext(49," Master System emulator",0);
	drawtext(50," Mighty ruler",0);
}

void drawclock() {

    char str[30];
    char *s=str+20;
    int timer,mod;

    if(rtc)
    {
	strcpy(str,"                    00:00:00");
	timer=gettime();
	mod=(timer>>4)&3;				//Hours.
	*(s++)=(mod+'0');
	mod=(timer&15);
	*(s++)=(mod+'0');
	s++;
	mod=(timer>>12)&15;				//Minutes.
	*(s++)=(mod+'0');
	mod=(timer>>8)&15;
	*(s++)=(mod+'0');
	s++;
	mod=(timer>>20)&15;				//Seconds.
	*(s++)=(mod+'0');
	mod=(timer>>16)&15;
	*(s++)=(mod+'0');

	drawtext(0,str,0);
    }
}

void autoAset() {
	autoA++;
	joycfg|=A_BTN+(A_BTN<<16);
	if(autoA==1)
		joycfg&=~A_BTN;
	else if(autoA==2)
		joycfg&=~(A_BTN<<16);
	else
		autoA=0;
}

void autoBset() {
	autoB++;
	joycfg|=B_BTN+(B_BTN<<16);
	if(autoB==1)
		joycfg&=~B_BTN;
	else if(autoB==2)
		joycfg&=~(B_BTN<<16);
	else
		autoB=0;
}

void controller() {					//see io.s: refreshEMUjoypads
	u32 i=joycfg+0x40000000;
	if(i>=0xc0000000)
		i&=~0xc0000000;
	resetSIO(i);					//reset link state
}

void sleepset() {
	stime++;
	if(stime==1)
		sleeptime=60*60*10;			// 10min
	else if(stime==2)
		sleeptime=60*60*30;			// 30min
	else if(stime==3)
		sleeptime=0x7F000000;		// 360days...
	else if(stime>=4){
		sleeptime=60*60*5;			// 5min
		stime=0;
	}
}

void vblset() {
	novblankwait++;
	novblankwait &=3;
}

void fpsset() {
	fpsenabled = (fpsenabled^1)&1;
}

void brightset() {
	gammavalue++;
	if (gammavalue>4) gammavalue=0;
	paletteinit();					//Change gamma of palette table.
	PaletteTxAll();					//make new palette visible
//	endframe();
	initpalette();
}

void multiboot() {
	int i;
	cls(1);
	drawtext(9,"          Sending...",0);
	i=SendMBImageToClient();
	if(i) {
		if(i<3)
			drawtext(9,"         Link error.",0);
		else
			drawtext(9,"  Game is too big to send.",0);
		if(i==2) drawtext(10,"       (Check cable?)",0);
		for(i=0;i<90;i++)			//wait a while
			waitframe();
	}
}

void restart() {
	writeconfig();					//save any changes
	scrolll(0,1);
	REG_TM0CNT=tm0cnt;				//resume sound (directsound)
	__asm {mov r0,#0x3007f00}		//stack reset
	__asm {mov sp,r0}
	rommenu();
}
void exit() {
	writeconfig();					//save any changes
	fadetowhite();
	REG_DISPCNT=FORCE_BLANK;		//screen OFF
	REG_BG0HOFS=0;
	REG_BG0VOFS=0;
	REG_BLDCNT=0;					//no blending
	(*(u8**)0x0203FBFC)=0;			//Pogo reset.
	doReset();
}

void sleep() {
	fadetowhite();
	suspend();
	setdarknessgs(7);				//restore screen
	while((~REG_P1)&0x3ff) {
		waitframe();				//(polling REG_P1 too fast seems to cause problems)
	}
}
void fadetowhite() {
	int i;
	for(i=7;i>=0;i--) {
		setdarknessgs(i);			//go from dark to normal
		waitframe();
	}
	for(i=0;i<17;i++) {				//fade to white
		setbrightnessall(i);		//go from normal to white
		waitframe();
	}
}

void scrolll(int offset, int f) {
	int i;
	for(i=0;i<9;i++)
	{
		if(f) setdarknessgs(8+i);	//Darken screen
		REG_BG3HOFS=i*32 + offset;	//Move screen left
		waitframe();
	}
}
void scrollr(int offset) {
	int i;
	for(i=8;i>=0;i--)
	{
		waitframe();
		REG_BG3HOFS=i*32 + offset;	//Move screen right
	}
	cls(2);							//Clear BG3
}

void ewramset() {
	ewram^=1;
	if(ewram==1){
		REG_WRWAITCTL = (REG_WRWAITCTL & ~0x0F000000) | 0x0E000000;		//1 waitstate, overclocked
	}else{
		REG_WRWAITCTL = (REG_WRWAITCTL & ~0x0F000000) | 0x0D000000;		//2 waitstates, normal
	}
}

void swapAB() {
	joycfg^=0x400;
}

void display() {
	char sc;
	g_scaling_set=sc=(g_scaling_set+1)&3;
	if(g_emuflags & GGMODE)
		sc=0;
	g_scaling=sc;
	spriteinit(sc);
	endframe();
	initpalette();
}

void flickset() {
	g_flicker++;
	if(g_flicker > 1){
		g_flicker=0;
		twitch=0;
	}
}

void toprowset() {
	toprows++;
	if(toprows > 2){
		toprows=0;
	}
}

void borderset() {
	bcolor++;
	if(bcolor>=3)
		bcolor=0;
	makeborder();
}

void countryset() {
	int i;
	g_region = (g_region+1)&3;
	i = (g_region)-1;
	if(i<0) i = 0;
	g_emuflags = (g_emuflags & ~3) | i;
	ntsc_pal_reset();
	frequency_reset();
	scanlinebp_reset();
}

void machineset() {
	g_machine_set++;
	if(g_machine_set > 5){
		g_machine_set=0;
	}
}

void biosset() {
	g_config_set^=0x80;
}

void rstartset() {
	g_config_set^=0x40;
}

void selectset() {
	g_config_set^=0x20;
}

void spriteset() {
	SPRS^=1;
}

void collisionset() {
	sprcollision^=0x20;
}

void autostateset() {
	autostate = (autostate^1)&1;
}

void sprlayerset(){
	gfxlayermask^=0x10;
}

void bgrlayerset(){
	gfxlayermask^=0x07;
}

void go_multiboot()
{
	u8 *src, *dest;
	int romsize,i;

	romsize = getromsize();
	src = (u8*)findrom(selectedrom);
	dest = (u8*)&Image$$RO$$Limit;
	if (romsize+((u32)(dest)&0x3ffff) > max_multiboot_size)
	{
		cls(1);
		drawtext(9, "Game is too big to multiboot",0);
		for(i=0;i<90;i++)			//wait a while
			waitframe();
		return;
	}

	memcpy(dest,src,romsize);
	textstart=dest;	
	selectedrom=0;
	g_BIOSBASE_SMS = 0;
	g_BIOSBASE_GG = 0;
	loadcart(selectedrom,g_emuflags&0x300);
	mainmenuitems=menuXitems[1];
	roms=1;
}

void soundset() {
}
